//Zarnescu Alexandru
//Proiect PM --- PONG GAME


#include <avr/io.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdio.h>
#include "pcd8544.h"

//	#define L 			0
//	#define J 			1
//	#define O 			2
//	#define S 			3
//	#define Z 			4
//	#define I 			5
//	#define T 			6


#define NO_BLOCKS	4
#define NO_PIECES	7
#define MAX_X		23
#define MAX_Y		15

#define JUC_1_SUS			1 << PC0 //0x01  -- JUC_1_SUS
#define RESET_GAME			1 << PC1 //0x02  -- RESET_GAME
#define JUC_1_JOS 		 	1 << PC2 //0x04  -- JUC_1_JOS
#define JUC_2_JOS 		 	1 << PC3 //0x08  -- JUC_2_JOS
#define JUC_2_SUS	 	 	1 << PC4 //0x10  -- JUC_2_SUS

uint32_t score = 0;

typedef struct {
	int8_t pos_x;	//coloana
	int8_t pos_y;	//linia
} patrat;

typedef struct {
	patrat sq[NO_BLOCKS];
} bara;

bara* mat_rot[NO_PIECES];
bara initial_piece[NO_PIECES];
bara racheta1, racheta2;
bara bila;

uint32_t table[16];
int8_t dir_x, valx, valy;
int8_t dir_y;
uint8_t next;
uint8_t max_move_allow;

void putBlock (byte x, byte y) {
	
	byte pixel_x = 3 * x;
	byte pixel_y = 3 * y;
	LcdPixel (pixel_x, pixel_y, PIXEL_ON);
	LcdPixel (pixel_x, pixel_y + 1, PIXEL_ON);
	LcdPixel (pixel_x, pixel_y + 2, PIXEL_ON);
	LcdPixel (pixel_x + 1, pixel_y, PIXEL_ON);
	LcdPixel (pixel_x + 1, pixel_y + 1, PIXEL_OFF);
	LcdPixel (pixel_x + 1, pixel_y + 2, PIXEL_ON);
	LcdPixel (pixel_x + 2, pixel_y, PIXEL_ON);
	LcdPixel (pixel_x + 2, pixel_y + 1, PIXEL_ON);
	LcdPixel (pixel_x + 2, pixel_y + 2, PIXEL_ON);
	
}

void showPiece(bara p)
{
	putBlock(p.sq[0].pos_x, p.sq[0].pos_y);
	putBlock(p.sq[1].pos_x, p.sq[1].pos_y);
	putBlock(p.sq[2].pos_x, p.sq[2].pos_y);
	putBlock(p.sq[3].pos_x, p.sq[3].pos_y);
}


uint8_t movePiece(bara *p, int8_t x, int8_t y)
{
	uint8_t i=0;
	
	if(p->sq[i].pos_y==0 && y == -1)
		return 0;
	if(p->sq[i].pos_y==15 && y == 1)
		return 0;
	
	
	for(i=0;i<4;i++){
		p->sq[i].pos_x += x;
		p->sq[i].pos_y += y;
		}
		
	return 0;
}


int pushButtons(uint8_t *pushAllow)
{
	if(!(PINC & JUC_1_SUS))
	{
		if(movePiece(&racheta1, 0, -1) == 0)
			*pushAllow = 0;
	}
	if(!(PINC & JUC_1_JOS))
	{
		if(movePiece(&racheta1, 0, +1) == 0)
			*pushAllow = 0;
	}
	if(!(PINC & JUC_2_SUS))
	{
		if(movePiece(&racheta2, 0, -1) == 0)
			*pushAllow = 0;
	}
	if(!(PINC & JUC_2_JOS))
	{
		if(movePiece(&racheta2, 0, +1) == 0)
			*pushAllow = 0;
	}
	
	if(!(PINC & RESET_GAME))
		return 1;
	
	return 0;
}



void initGame () {
	
	DDRC = 0x00;
	PORTC = 0xFF;

	dir_x = 1;
	dir_y = 0;
	
	racheta1.sq[0].pos_x = 1;
	racheta1.sq[0].pos_y = 6;
	racheta1.sq[1].pos_x = 1;
	racheta1.sq[1].pos_y = 7;
	racheta1.sq[2].pos_x = 1;
	racheta1.sq[2].pos_y = 8;
	racheta1.sq[3].pos_x = 1;
	racheta1.sq[3].pos_y = 9;
	
	racheta2.sq[0].pos_x = 25;
	racheta2.sq[0].pos_y = 6;
	racheta2.sq[1].pos_x = 25;
	racheta2.sq[1].pos_y = 7;
	racheta2.sq[2].pos_x = 25;
	racheta2.sq[2].pos_y = 8;
	racheta2.sq[3].pos_x = 25;
	racheta2.sq[3].pos_y = 9;
	
	bila.sq[0].pos_x = 10;
	bila.sq[0].pos_y = 7;


}

void showMenu() {
	LcdGotoXYFont(1, 1);
	LcdFStr(FONT_1X,(unsigned char*)PSTR("Apasa butonul de start!"));
    LcdUpdate();
}

int main() {	
	int8_t i, fac_reset = 0;
	uint8_t u;
	int8_t nu_am_terminat =0;
	initGame ();
	LcdInit();
	LcdClear();


	while (1) {
	
	
		//LcdClear();
		//showMenu(); 
		
		while(nu_am_terminat==0 && fac_reset == 0){
			
			showPiece(racheta1);
			showPiece(racheta2);
			//showPiece(bila);
			
			valx = 3 * bila.sq[0].pos_x;
			valy = 3 * bila.sq[0].pos_y;
			LcdPixel (valx, valy, PIXEL_ON);
			LcdPixel (valx, valy + 1, PIXEL_ON);
			LcdPixel (valx, valy + 2, PIXEL_ON);
			LcdPixel (valx + 1, valy, PIXEL_ON);
			LcdPixel (valx + 1, valy + 1, PIXEL_OFF);
			LcdPixel (valx + 1, valy + 2, PIXEL_ON);
			LcdPixel (valx + 2, valy, PIXEL_ON);
			LcdPixel (valx + 2, valy + 1, PIXEL_ON);
			LcdPixel (valx + 2, valy + 2, PIXEL_ON);
					
			
			if (pushButtons(&u) == 1)
				fac_reset = 1;
			
			if(fac_reset == 1)
				initGame();
			
			if(bila.sq[0].pos_x == 1){//daca am ajuns la capatul stanga
				if(racheta1.sq[0].pos_y!=bila.sq[0].pos_y && racheta1.sq[1].pos_y!=bila.sq[0].pos_y && racheta1.sq[2].pos_y!=bila.sq[0].pos_y && racheta1.sq[3].pos_y!=bila.sq[0].pos_y)
					nu_am_terminat = 1;
				else{
					dir_x = 0-dir_x;
					dir_y = 0-dir_y;
					}
			}
			
			if(bila.sq[0].pos_x == 25){//daca am ajuns la capatul dreapta
				if(racheta2.sq[0].pos_y!=bila.sq[0].pos_y && racheta2.sq[1].pos_y!=bila.sq[0].pos_y && racheta2.sq[2].pos_y!=bila.sq[0].pos_y && racheta2.sq[3].pos_y!=bila.sq[0].pos_y)
					nu_am_terminat = 1;
				else{
					dir_x = 0-dir_x;
					dir_y = 0-dir_y;
				}
			}
				
			if(bila.sq[0].pos_y == 1 || bila.sq[0].pos_y == 15)
				dir_y = 0-dir_y;
				
			bila.sq[0].pos_x+=dir_x;
			bila.sq[0].pos_y+=dir_y;
			
			
			LcdUpdate();	
			_delay_ms(1000);	

		}
		
		LcdClear();
		LcdGotoXYFont(1, 1);
		LcdFStr(FONT_1X,(unsigned char*)PSTR("Game over, made by AZ"));
		LcdUpdate();
		nu_am_terminat=0;
		fac_reset=0;
		_delay_ms(5000);
		
		LcdClear();
		LcdGotoXYFont(1, 1);
		LcdFStr(FONT_1X,(unsigned char*)PSTR("Apasa butonul de start!"));
		LcdUpdate();

		while((PINC & RESET_GAME)) 
			;
		LcdClear();	
	}
	
	return 0;
}